=== debian/control ===
Source: openswan
Section: net
Priority: optional
Maintainer: Simon Deziel <simon@xelerance.com>
Standards-Version: 3.9.6
Vcs-Browser: https://github.com/xelerance/Openswan.git
Vcs-Git: git://github.com/xelerance/Openswan.git
Build-Depends: dpkg-dev (>= 1.16.1.1), debhelper (>= 7.1), libgmp3-dev, libssl-dev (>= 0.9.8), libcurl4-openssl-dev, libldap2-dev, libpam0g-dev, libkrb5-dev, bison, flex, bzip2, po-debconf, xmlto
Homepage: https://www.openswan.org/

Package: openswan
Architecture: linux-any
Pre-Depends: debconf | debconf-2.0
Depends: ${shlibs:Depends}, ${misc:Depends}, bsdmainutils, openssl, host, iproute2 | ipsec-tools
Recommends: python
Suggests: openswan-modules-source | openswan-modules-dkms, openswan-doc, curl
Provides: ike-server
Conflicts: ike-server
Replaces: ike-server
Description: Internet Key Exchange daemon
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 The Openswan IKE daemon is named pluto. It was inherited from the FreeS/WAN
 project, but provides improved X.509 certificate support and other features.
 .
 In order to use the KLIPS IPsec code instead of the native version, you will
 need to either install openswan-modules-source and build the appropriate
 module for your kernel or use openswan-modules-dkms which automates this
 task.

Package: openswan-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ${misc:Depends}, openswan (= ${binary:Version})
Description: Internet Key Exchange daemon - debugging symbols
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 This package provides the symbols needed for debugging of openswan
 binaries.

Package: openswan-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Internet Key Exchange daemon - documentation
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 This package provides the free parts of the documentation for Openswan.

Package: openswan-modules-source
Architecture: all
Section: kernel
Depends: ${misc:Depends}, debhelper, bzip2
Recommends: module-assistant | kernel-package, linux-headers | linux-source
Suggests: openswan
Description: Internet Key Exchange daemon - kernel module source
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 For support of the old-style KLIPS ipsecX network interfaces a custom
 kernel module is needed.
 .
 This package contains source code for the Openswan IPsec kernel module,
 which can be used with tools like module-assistant or kernel-package
 for manual building of local kernel images.
 .
 Kernel versions >= 2.6.23 no longer need to be patched to provide NAT
 Traversal support for KLIPS.

Package: openswan-modules-dkms
Architecture: linux-any
Section: kernel
Depends: ${misc:Depends}, dkms, openswan
Description: Internet Key Exchange daemon - DKMS source
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 For support of the old-style KLIPS ipsecX network interfaces a custom
 kernel module is needed.
 .
 This package contains source code for the Openswan IPsec kernel module,
 which can be used with DKMS so that local kernel images are automatically
 built and installed every time relevant kernel packages are upgraded.
 .
 Kernel versions >= 2.6.23 no longer need to be patched to provide NAT
 Traversal support for KLIPS.
