=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# The build system doesn't respect CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
# enable the missing (hardening) flags.
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

build-arch: build
build-indep: build
build: build-stamp
build-stamp:
	# create a dummy ipsec.secrets file before building the package so
	# that no RSA keys are created during the build process
	# (a package should not include a RSA key, it should produce the key
	# on demand, e.g. in the postinst script)
	touch $(CURDIR)/debian/ipsec.secrets
	$(MAKE) programs INC_USRLOCAL=/usr \
			 FINALBINDIR=/usr/lib/ipsec \
			 FINALLIBEXECDIR=/usr/lib/ipsec \
			 PUBDIR=/usr/sbin \
			 MANTREE=/usr/share/man \
			 CONFDIR=$(CURDIR)/debian \
			 USE_LDAP=true USE_LIBCURL=true \
			 USE_XAUTHPAM=true
	# remove the temporary file, it will be created during install
	rm -f $(CURDIR)/debian/ipsec.secrets

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	[ ! -f Makefile ] || $(MAKE) clean

	# after a make clean, no binaries _should_ be left, but ....
	-find $(CURDIR) -name "*.o" | xargs --no-run-if-empty rm
	-find $(CURDIR)/lib/libcrypto -name "*.a" | xargs --no-run-if-empty rm

	rm -rf debian/openswan-modules-source-build/

	# Really clean (#356716)
	# This is a hack: should be better implemented
	rm -f lib/libopenswan/libopenswan.a || true
	rm -f lib/libopenswan/liboswlog.a || true
	rm -rf OBJ.* || true

	# just in case something went wrong
	rm -f $(CURDIR)/debian/ipsec.secrets

	# and make sure that template are up-to-date
	debconf-updatepo

	dh_clean

install-openswan: DH_OPTIONS=-a
install-openswan: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install INC_USRLOCAL=/usr \
			FINALBINDIR=/usr/lib/ipsec \
			FINALLIBEXECDIR=/usr/lib/ipsec \
			PUBDIR=$(CURDIR)/debian/openswan/usr/sbin \
			MANTREE=$(CURDIR)/debian/openswan/usr/share/man \
			DESTDIR=$(CURDIR)/debian/openswan
	rm -rf $(CURDIR)/debian/openswan/usr/local
	install --mode=0600 $(CURDIR)/debian/ipsec.secrets.proto $(CURDIR)/debian/openswan/etc/ipsec.secrets

	rm -f $(CURDIR)/debian/openswan/etc/init.d/ipsec?*
	rm -f $(CURDIR)/debian/openswan/usr/lib/ipsec/_plutorun?*

	# this is handled by update-rc.d
	rm -rf $(CURDIR)/debian/openswan/etc/rc?.d

	# delete var/lock/subsys and var/run to satisfy lintian
	rm -rf $(CURDIR)/debian/openswan/var/lock
	rm -rf $(CURDIR)/debian/openswan/var/run

	# remove the already installed docs
	rm -rf "$(CURDIR)/debian/openswan/usr/share/doc"

	# fix some manpage issues
	for oldname in `find $(CURDIR)/debian/openswan/usr/share/man -name "ipsec_ipsec*"`; \
	do \
	    newname=`echo "$$oldname" | sed 's/ipsec_ipsec_/ipsec_/'`; \
	    if [ -f "$$newname" ]; then \
		rm -f "$$oldname"; \
	    else \
		mv "$$oldname" "$$newname"; \
	    fi; \
	done

	dh_installdocs -popenswan -n
	dh_installchangelogs CHANGES

	# openswan-dbg depends on openswan so no need to ship doc twice
	rm -rf $(CURDIR)/debian/openswan-dbg/usr/share/doc/openswan-dbg

	# the logcheck ignore files
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.paranoid $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.paranoid/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.server/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.workstation/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.violations.ignore $(CURDIR)/debian/openswan/etc/logcheck/violations.ignore.d/openswan

	# set permissions on ipsec.secrets
	chmod 600 $(CURDIR)/debian/openswan/etc/ipsec.secrets
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.conf
	chmod 700 -R $(CURDIR)/debian/openswan/etc/ipsec.d/private/
	# don't know why they come with +x set by default...
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/policies/*
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/examples/*

	# create /var/lib/openswan with permissions similar to ipsec.secrets
	mkdir -p $(CURDIR)/debian/openswan/var/lib/openswan
	chmod 700 -R $(CURDIR)/debian/openswan/var/lib/openswan

	# more lintian cleanups
	find $(CURDIR)/debian/openswan -name ".gitignore" | xargs --no-run-if-empty rm -f

	# Empty directory
	rmdir $(CURDIR)/debian/openswan/usr/bin

install-openswan-doc: DH_OPTIONS=-popenswan-doc
install-openswan-doc: build
	dh_testdir
	dh_testroot

	dh_installdocs -popenswan-doc -n
	dh_installchangelogs CHANGES

	# fix some doc issues
	for oldname in `find $(CURDIR)/debian/openswan-doc/usr/share/doc -name "ipsec_ipsec*"`; \
	do \
	    newname=`echo "$$oldname" | sed 's/ipsec_ipsec_/ipsec_/'`; \
	    if [ -f "$$newname" ]; then \
		rm -f "$$oldname"; \
	    else \
		mv "$$oldname" "$$newname"; \
	    fi; \
	done

	# change the paths in the installed doc files (but only in regular
	# files, not in links to the outside of the build tree !)
	( cd $(CURDIR)/debian/openswan-doc/; \
	  for f in `grep "/usr/local/" --recursive --files-with-match *`; \
	  do \
		if [ -f $$f -a ! -L $$f ]; then \
		    cp $$f $$f.old; \
		    sed 's/\/usr\/local\//\/usr\//' $$f.old > $$f; \
		    rm $$f.old; \
		fi; \
	  done )
	# but remove the doc/src dir, which just duplicates the HTML files
	rm -rf $(CURDIR)/debian/openswan-doc/usr/share/doc/openswan-doc/doc/src

	# more lintian cleanups
	find $(CURDIR)/debian/openswan-doc -name ".gitignore" | xargs --no-run-if-empty rm -f

install-openswan-modules-source: DH_OPTIONS=-popenswan-modules-source
install-openswan-modules-source: PKGDIR=$(CURDIR)/debian/openswan-modules-source
install-openswan-modules-source: BUILDDIR=$(CURDIR)/debian/openswan-modules-source-build
install-openswan-modules-source:
	dh_testdir
	dh_testroot
	dh_installdirs
	mkdir -p "$(BUILDDIR)/modules/openswan"
	mkdir -p "$(BUILDDIR)/modules/openswan/lib"
	mkdir -p "$(BUILDDIR)/modules/openswan/debian"
	mkdir -p "$(BUILDDIR)/modules/openswan/packaging"
	mkdir -p "$(BUILDDIR)/modules/openswan/patches/kernel"
	cp -r CHANGES CREDITS Makefile Makefile.top Makefile.inc Makefile.ver linux/ \
		"$(BUILDDIR)/modules/openswan"
	cp -r lib/libcrypto "$(BUILDDIR)/modules/openswan/lib/"
	cp -r packaging/makefiles packaging/linus packaging/utils packaging/defaults/ packaging/ocf \
		"$(BUILDDIR)/modules/openswan/packaging/"
	cp -r patches/kernel/2.6.32 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/2.6.34 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/2.6.35 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/2.6.38 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/3.0.0  "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/3.2.0  "$(BUILDDIR)/modules/openswan/patches/kernel/"
	find "$(BUILDDIR)/modules/openswan/lib/" -name "*.o" | xargs --no-run-if-empty rm
	install --mode=644 debian/openswan-modules-source.kernel-config "$(BUILDDIR)/modules/openswan/config-all.h"
	install --mode=755 debian/openswan-modules-source.rules "$(BUILDDIR)/modules/openswan/debian/rules"
	install --mode=644 debian/openswan-modules-source.control.in "$(BUILDDIR)/modules/openswan/debian/control.in"
	install --mode=644 debian/openswan-modules-source.docs "$(BUILDDIR)/modules/openswan/debian/docs.in"
	install --mode=644 debian/openswan-modules-source.lintian-overrides.in "$(BUILDDIR)/modules/openswan/debian/lintian-overrides.in"
	install --mode=644 debian/compat "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/changelog "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/copyright "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/NEWS "$(BUILDDIR)/modules/openswan/debian/"
